typedef struct mac_t {  /* MAC addresses */
        unsigned char device[6];
        unsigned char mcast1[6];
        unsigned char mcast2[6];
        unsigned char mcast3[6];
        unsigned char dflt_srv[6];
} MAC_t;

typedef struct cnfg_t {  /* Configuration elements */
        MAC_t mac;
        short int ether;
        short int ext_fifo;
        short int reset;
        int vme;
        short int vme_bto;
        short int vme_bgto;
} CNFG_t;

typedef CNFG_t *CNFG_ptr;

enum MAC_ID {DEVICE=0, MCAST1=1, MCAST2=2, MCAST3=3, DFLT_SRV=4, ALL_MACS=8};

enum CR_ID {ETHER=0, EXTFIFO=1, RESET=2, VME=3, BTO=4, BGTO=5, ALL_CRS=8};

CNFG_ptr load_cnfg(char *fn);
int write_cnfg(CNFG_ptr cp, char *fn);
int set_cnfg_dflt(int dflt);
int read_cnfg_dflt();
int save_cnfg_num(int cnum);
int rstr_cnfg_num(int cnum);
int read_cnfg_num_dir(int cnum, char **dpp);
CNFG_ptr read_cnfg_num_dcd(int cnum);
CNFG_ptr read_crs();
int set_macs(enum MAC_ID mcid, CNFG_ptr cp);
int read_macs_dir(char **dpp);
CNFG_ptr read_macs_dcd();
int wrt_crs(enum CR_ID crid, CNFG_ptr cp);
void cp_macs(CNFG_ptr to, CNFG_ptr from);
void cp_crs(CNFG_ptr to, CNFG_ptr from);
void cp_cnfg(CNFG_ptr to, CNFG_ptr from);
void print_macs(CNFG_ptr cp);
void print_crs(CNFG_ptr cp);
void print_cnfg(CNFG_ptr cp);

#define CNFG_MAXLINE 256
